(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory(require("R"), require("RA"));
	else if(typeof define === 'function' && define.amd)
		define(["R", "RA"], factory);
	else if(typeof exports === 'object')
		exports["JsonApiMerge"] = factory(require("R"), require("RA"));
	else
		root["JsonApiMerge"] = factory(root["R"], root["RA"]);
})(window, function(__WEBPACK_EXTERNAL_MODULE__1__, __WEBPACK_EXTERNAL_MODULE__2__) {
return /******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId]) {
/******/ 			return installedModules[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, { enumerable: true, get: getter });
/******/ 		}
/******/ 	};
/******/
/******/ 	// define __esModule on exports
/******/ 	__webpack_require__.r = function(exports) {
/******/ 		if(typeof Symbol !== 'undefined' && Symbol.toStringTag) {
/******/ 			Object.defineProperty(exports, Symbol.toStringTag, { value: 'Module' });
/******/ 		}
/******/ 		Object.defineProperty(exports, '__esModule', { value: true });
/******/ 	};
/******/
/******/ 	// create a fake namespace object
/******/ 	// mode & 1: value is a module id, require it
/******/ 	// mode & 2: merge all properties of value into the ns
/******/ 	// mode & 4: return value when already ns object
/******/ 	// mode & 8|1: behave like require
/******/ 	__webpack_require__.t = function(value, mode) {
/******/ 		if(mode & 1) value = __webpack_require__(value);
/******/ 		if(mode & 8) return value;
/******/ 		if((mode & 4) && typeof value === 'object' && value && value.__esModule) return value;
/******/ 		var ns = Object.create(null);
/******/ 		__webpack_require__.r(ns);
/******/ 		Object.defineProperty(ns, 'default', { enumerable: true, value: value });
/******/ 		if(mode & 2 && typeof value != 'string') for(var key in value) __webpack_require__.d(ns, key, function(key) { return value[key]; }.bind(null, key));
/******/ 		return ns;
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";
/******/
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = 0);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


exports.__esModule = true;
exports["default"] = void 0;

var _ramda = __webpack_require__(1);

var _ramdaAdjunct = __webpack_require__(2);

// Type definitions:
//     Resource = Object
//     ResourceRel = {type: String, id: Number}
//     ResourceKey = String
//     Relationships = Object
//     Included = [Resource]
//     IncludedCache = {k: ResourceKey, v: Resource}
//     RelPath = {path: String, key: ResourceKey}
// getRelationships :: Resource -> Relationships
var getRelationships = (0, _ramda.pipe)((0, _ramda.propOr)({}, ['relationships']), _ramda.keys); // resourceKey :: ResourceRel -> ResourceKey

var resourceKey = function resourceKey(_ref) {
  var type = _ref.type,
      id = _ref.id;
  return "".concat(type, "-").concat(id);
}; // createIncludedCache :: Included -> IncludedCache


var createIncludedCache = (0, _ramda.reduce)(function (acc, resource) {
  return (0, _ramda.assoc)(resourceKey(resource), resource, acc);
}, {}); // relToPath :: (String, ResourceRel) -> RelPath

var relToPath = function relToPath(relationship, _ref2) {
  var type = _ref2.type,
      id = _ref2.id;
  return {
    path: ['relationships', relationship, 'data'],
    key: resourceKey({
      type: type,
      id: id
    })
  };
}; // relToPaths :: (String, [ResourceRel]) -> [RelPath]


var relToPaths = function relToPaths(relationship, resources) {
  return (0, _ramdaAdjunct.mapIndexed)(function (resource, index) {
    return {
      path: ['relationships', relationship, 'data', index],
      key: resourceKey(resource)
    };
  }, resources);
}; // getRelPaths :: Resource -> [RelPath]


var getRelPaths = function getRelPaths(resource) {
  var relationships = getRelationships(resource);
  return (0, _ramda.reduce)(function (acc, relationship) {
    var relData = resource.relationships[relationship].data;
    var paths = (0, _ramdaAdjunct.ensureArray)((0, _ramdaAdjunct.isArray)(relData) ? relToPaths(relationship, relData) : relToPath(relationship, relData));
    return (0, _ramda.concat)(acc, paths);
  }, [], relationships);
}; // jsonApiMergeSingle :: (Included, Resource) -> Resource


var jsonApiMergeSingle = function jsonApiMergeSingle(includedCache, resource) {
  var relPaths = getRelPaths(resource);
  return (0, _ramda.reduce)(function (acc, _ref3) {
    var key = _ref3.key,
        path = _ref3.path;
    var includedResource = (0, _ramda.has)(key, includedCache) ? includedCache[key] : (0, _ramda.path)(path, resource);
    return (0, _ramda.assocPath)(path, includedResource, acc);
  }, resource, relPaths);
}; // jsonApiMergeMulti :: (IncludedCache, [Resource]) -> [Resource]


var jsonApiMergeMulti = function jsonApiMergeMulti(includedCache, resources) {
  return (0, _ramdaAdjunct.reduceIndexed)(function (acc, datum, index) {
    var mergedDatum = jsonApiMergeSingle(includedCache, datum);
    return (0, _ramda.insert)(index, mergedDatum, acc);
  }, [], resources);
}; // jsonApiMerge :: (Included, Resource) -> Resource
// jsonApiMerge :: (Included, [Resource]) -> [Resource]


var jsonApiMerge = (0, _ramda.curry)(function (included, resource) {
  if ((0, _ramda.isNil)(included)) return resource;
  var includedCache = createIncludedCache(included);
  return (0, _ramdaAdjunct.isArray)(resource) ? jsonApiMergeMulti(includedCache, resource) : jsonApiMergeSingle(includedCache, resource);
});
var _default = jsonApiMerge;
exports["default"] = _default;

/***/ }),
/* 1 */
/***/ (function(module, exports) {

module.exports = __WEBPACK_EXTERNAL_MODULE__1__;

/***/ }),
/* 2 */
/***/ (function(module, exports) {

module.exports = __WEBPACK_EXTERNAL_MODULE__2__;

/***/ })
/******/ ])["default"];
});